clear all
clc
% clc;
randn('state',1); rand('state',1); %#ok<RAND>
caseIDs=1:10;
nrRuns = size(caseIDs, 2);
%% Generate CP tensor
load('100100100R5.mat')

normalize            =       max(X0(:))   ;
X                    =        X0/normalize;

caseIDs=[5]
for itnr = caseIDs
    %% parameters to setup the problem
    switch itnr
        case 1
            SparseRatio = 0.1
        case 2
            SparseRatio = 0.2
        case 3
            SparseRatio =  0.3
        case 4
            SparseRatio = 0.4
        case 5
            SparseRatio =  0.5
        case 6
            SparseRatio =  0.6
        case 7
            SparseRatio =  0.7
        case 8
            SparseRatio =  0.8
        case 9
            SparseRatio = 0.9
    end
    %     results.percentage_available(itnr) = ObsRatio;

    %     results.percentage_available(itnr) = ObsRatio;
    DIM = size(X);
    Omega0 = randperm(prod(DIM));
    Omega0 = Omega0(1:round(1*prod(DIM)));
    O = zeros(DIM);
    O(Omega0) = 1;
    Omega=logical(O);
    %% Generate sparse tensor
    SparseRatio = 0.1
    Somega = randsample(prod(DIM), round(prod(DIM)*SparseRatio));
    S = zeros(DIM);
    % S(Somega) = 10*std(X(:))*(2*rand(length(Somega),1)-1); % sparse component
    S(Somega) = max(X(:))*(2*rand(length(Somega),1)-1); % sparse component
    %% Generate observation tensor Y
    T1= X + S;
    T=T1.*O;
    maxIter = 500
    epsilon = 1e-15
    
    InitialR =round(0.5*mean(size(X)))
    
    fr= 1e-3*(SparseRatio);  % threhold for rank estimation, it could be even smaller;
    mu    =10/(sqrt(mean(size(X))*(1-SparseRatio)))*(max(T(:)))

    tic
    [Z,TubalR,TimeRE] = RTPCA_RE(...
        T,...                     % The incomplete matrix whose elements in Omega are used for estimating missing value;
        mu,...                    % The parameter of the L1-norm regularzation term; always set it as 30;
        maxIter,...               % The maximum iterations;
        epsilon,...               % The stop tolerance of the error of approximation Z and input X on observed entries;
        InitialR);                    % The initial maximum rank for target matrix);
    
    results.TimeRE(1, itnr) = TimeRE;
    results.TimeTC(1, itnr) = toc;
    results.RSE_RTPCA(1, itnr) = norm(Z(:)-X(:),'fro') /norm(X(:),'fro')
    results.Rank(1, itnr) = TubalR;

   
    

end