function [Z,TubalR,TimeRE] = RTC_RE_uv(T, Omega,Lambda, maxIter, epsilon,InitialR)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Created by Qiquan on 14/03/2018 -RTC_RE
% Updated by Qiquan on 1/05/2019 --  (1) RTC-RE - Alternative version
sizeT = size(T);
Z=zeros(sizeT);
X1=Z;
ZEQ=zeros(sizeT);
ZEQQ=zeros(sizeT);
dY12=zeros(sizeT);
dY1=zeros(sizeT);
ZE=zeros(sizeT);

Y1=zeros(sizeT);
Y2=zeros(sizeT);
E=zeros(sizeT);
seights_L= zeros(maxIter, 1);
schange=zeros(maxIter, InitialR);

[N,M,G] = size(T);
DDD = length(size(T));
MutiR= zeros(DDD, 1);
fr= 1e-3*length(find(Omega==1))/prod(sizeT)
QTErrlist=zeros(maxIter, 1);
QTErrlistTC=zeros(maxIter, 1);
mu= 1e-4
[n1,n2,n3] = size(T);
% Beta1= 1e+4
Beta1 = 1/sqrt(max(n1,n2)*n3) %0.1
max_Beta = 1e10;
rho = 1.05;
max_Beta = 1e10;
XQQQ=zeros(sizeT);
% X(~Omega) = mean(T(Omega));
%% Iteration Scheme
X=T;
Z=X;
Y1=X;
% Y2=X;
tic
for k = 1: maxIter
    XOld=X;
    mu=1/Lambda;
    Temp=Z - Y2/mu;
    for idd=3:DDD
        Temp= fft(Temp,[],idd);
    end
    Z2=Temp;
    for fi2 = 1: G
        [U2 S2 V2]=ntsvdQQ(Z2(:,:,fi2));
        U=U2(:,1:InitialR);
        V=V2(:,1:InitialR);
        S=S2(1:InitialR,1:InitialR);
        s=diag(S);
%         s_old=s;
        Xr = Z2(:,:,fi2);
        % Updating U S V
        for r= 1 : InitialR
            if s(r) ~= 0
                index0=find(abs(s(1:r))>0);
                R0=length(index0);
                Xrn=Xr*V(:,r);
                u1=zeros(sizeT(1),1);
                for q=1:R0-1
                    u1=u1 +U(:,index0(q))'*double(Xrn(:))*U(:,index0(q));
                end
                midU1 =(Xrn(:)- u1)/(s(r));
                if   norm(midU1(:)) ~= 0
                    U(:,r)= midU1/norm(midU1(:));
                    Xrn=Xr'*U(:,r);
                    u2=zeros(sizeT(2),1);
                    for q=1:R0-1
                        u2=u2+V(:,index0(q))'*Xrn(:)*V(:,index0(q));
                    end
                    midU2 =(Xrn(:)- u2)/(s(r));
                    if   norm(midU2(:)) ~= 0
                        V(:,r)= midU2/norm(midU2(:));
                        DO=U(:,r)'*Xr*V(:,r);
                        s(r) = soft(DO,Lambda);
                        seights_L(k,r)=s(r);
                        Xr =  Xr - s(r)*U(:,r)*V(:,r)';  % Residual of approximation
                    end
                end
            end
        end
        XQQQ(:,:,fi2) = U*diag(s)*V';
        
        
        %% Estimate the real rank of the incomplete tensor
              
        index1=find(s/sum(s)>fr);
        Noabs =length(index1);
        index2=find(abs(s)/sum(abs(s))>fr);
        ABSs =length(index2);
        index3=find(s>0);
        Large0=length(index3);
        R=min([Noabs,ABSs,Large0]);
      
        MutiR(fi2)=R;
    end
    
    X=ifft(XQQQ,[],DDD);
    
    temp = T-Y1/mu;
    temp(Omega) = temp(Omega)-Z(Omega);
    E = prox_l1(temp,Beta1/mu);
    
    Z(Omega) = (T(Omega)-E(Omega)+X(Omega)-(Y1(Omega)-Y2(Omega))/mu)/2;
    Z(~Omega) = X(~Omega)+Y2(~Omega)/mu;
    
    dY1 = E-T;
    dY1(Omega) = dY1(Omega)+Z(Omega);
    dY2 = X-Z;
    Y1 = Y1 + mu*dY1;
    Y2 = Y2 + mu*dY2;
    mu = min(rho*mu,max_Beta);
    
    QTErrlist(k,1)=norm(XOld(:)-X(:))/norm(X(:));
    if QTErrlist(k,1) < 1e-5
        fprintf('******** RTSVD error = %d, iterations = %d******** \n \n ', QTErrlist(k,1),k);
        break;
    end
    InitialR = R;
    if k/100 ==1
       fprintf('******** InitialR changed at iterations = %d and InitialR = %d******** \n \n ', k,InitialR);
    end 
end
TubalR=max(MutiR)
% TubalR=min(MutiR)
% TubalR=InitialR
% mu= 1e-4
TimeRE=toc
for k2 = 1: maxIter
    QOld=X;
    
    Temp2=Z - Y2/mu;
    for idd=3:DDD
        Temp2= fft(Temp2,[],idd);
    end
    Z2=Temp2;
    for fi2 = 1: G
        [U20 S20 V20]= svd(Z2(:,:,fi2));
        U3=U20(:,1:TubalR);
        V3=V20(:,1:TubalR);
        S3=S20(1:TubalR,1:TubalR);
        s = diag(S3);
        S30 = max(s-1/mu,0);
        
        S3=diag(S30);
        XQQQ2(:,:,fi2) = U3*S3*V3';
        
        %% Estimate the real rank of the incomplete tensor
    end
    X=ifft(XQQQ2,[],3);
    temp = T-Y1/mu;
    temp(Omega) = temp(Omega)-Z(Omega);
    E = prox_l1(temp,Beta1/mu);
    
    Z(~Omega) = X(~Omega)+Y2(~Omega)/mu;
    Z(Omega) = 0.5*(T(Omega)-E(Omega)+X(Omega)-(Y1(Omega)-Y2(Omega))/mu);
    
    dY1 = E-T;
    dY1(Omega) = dY1(Omega)+Z(Omega);
    dY2 = X-Z;
    Y1 = Y1 + mu*dY1;
    Y2 = Y2 + mu*dY2;
    mu = min(rho*mu,max_Beta);
    
    QTErrlistTC(k2,1)=norm(QOld(:)-X(:))/norm(X(:));
    if QTErrlistTC(k2,1) < epsilon
        fprintf('******** RTSVD-ARD  error = %d, iterations = %d******** \n \n ', QTErrlistTC(k2,1),k2);
        
        break;
    end
end

    function y = soft(x,T)
        if sum(abs(T(:)))==0
            y = x;
        else
            y = max(abs(x) - T, 0);
            y = sign(x).*y;
        end
    end
    function x = prox_l1(b,lambda)

        
        x = max(0,b-lambda)+min(0,b+lambda);
    end
end