function [Z2,TubalR,TimeARD] = TC_RE(T, Omega,Lambda, maxIter, epsilon,InitialR)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Created by Qiquan on 03/01/2018
% Revised by Qiquan on 16/01/2018

sizeT = size(T);
Z=zeros(sizeT);
seights_L= zeros(maxIter, 1);
schange=zeros(maxIter, InitialR);
MutiR= zeros(sizeT(3), 1);
[N,M,G] = size(T);
DDD = length(size(T));
fr= 1e-3*length(find(Omega==1))/prod(sizeT)
QTErrlist=zeros(maxIter, 1);
QTErrlistTC=zeros(maxIter, 1);
% X(~Omega) = mean(T(Omega));
tic
%% Iteration Scheme
X=T;
for k = 1: maxIter
    Temp=X;
    for idd=3:DDD
        Temp= fft(Temp,[],idd);
    end
    Z=Temp;
    XOld=X;

    for fi = 1: G
        [U20 S20 V20]= svd(Z(:,:,fi));
        U3=U20(:,1:InitialR);
        V3=V20(:,1:InitialR);
        S30=S20(1:InitialR,1:InitialR);
        s00 = diag(S30);
        S30 = soft(s00,Lambda);
        
        S3=diag(S30);
        XQQQ(:,:,fi) = U3*S3*V3';
        
        %% Estimate the real rank of the incomplete tensor
        index1=find(S30/sum(S30)>fr);
        Noabs =length(index1);
        index2=find(abs(S30)/sum(abs(S30))>fr);
        ABSs =length(index2);
        index3=find(S30>0);
        Large0=length(index3);
        R=min([Noabs,ABSs,Large0]);
        MutiR(fi)=R     ;
    end
    X=ifft(XQQQ,[],DDD);
    X(Omega)=T(Omega);

    QTErrlist(k,1)=norm(XOld(:)-X(:))/norm(X(:));
    if QTErrlist(k,1) < 1e-5
        fprintf('******** RTSVD error = %d, iterations = %d******** \n \n ', QTErrlist(k,1),k);
        break;
    end
    InitialR = R;
    if k/100 ==1
       fprintf('******** InitialR changed at iterations = %d and InitialR = %d******** \n \n ', k,InitialR);
    end 
end
TubalR=max(MutiR);
TimeARD=toc
Z2=X;
for k2 = 1: maxIter
         QOld=Z2;
         Z2 = fft(Z2,[],3);
        for fi2 = 1: size(T,3)
            [U20 S20 V20]= svd(Z2(:,:,fi2));
            U3=U20(:,1:TubalR);
            V3=V20(:,1:TubalR);
            S3=S20(1:TubalR,1:TubalR);
            XQQQ2(:,:,fi2) = U3*S3*V3';
       end
    Z2=ifft(XQQQ2,[],3);
    Z2(Omega)=T(Omega);
    QTErrlistTC(k2,1)=norm(QOld(:)-Z2(:))/norm(Z2(:));
    if QTErrlistTC(k2,1) < epsilon
        fprintf('******** TC-ARD  error = %d, iterations = %d******** \n \n ', QTErrlistTC(k2,1),k2);
        
        break;
    end
end

    function y = soft(x,T)
        if sum(abs(T(:)))==0
            y = x;
        else
            y = max(abs(x) - T, 0);
            y = sign(x).*y;
        end
    end
end